//YWROBOT
//Compatible with the Arduino IDE 1.0
//Library version:1.1
#include <Wire.h> 
#include <LiquidCrystal_I2C.h>

LiquidCrystal_I2C lcd(0x3f,16,2);  // set the LCD address to 0x27 for a 16 chars and 2 line display
#include "DHT.h"

#define DHTPIN 2     // what digital pin we're connected to

#define DHTTYPE DHT22   // DHT 22  (AM2302), AM2321
DHT dht(DHTPIN, DHTTYPE);
#include <SoftwareSerial.h>

#define pmsDataLen  24
uint8_t pmsDatabuf[pmsDataLen];

SoftwareSerial pmsSerial(6, 5); // RX, TX
bool CheckSum(uint8_t *__buf, int __n)
{
  bool __flag = false; int __sum = 0;

  for(int i=0; i<(__n-2); i++)
  {
    __sum += __buf[i];
  }
  
  if(__sum == ((__buf[__n-2]<<8) + __buf[__n-1]))
  {
    __flag = true;
  }

  return __flag;
}

void setup()
{
  pinMode(9, OUTPUT);
  pinMode(10, OUTPUT);
  pinMode(11, OUTPUT);
  pinMode(12, OUTPUT);
  digitalWrite(12, LOW);
  lcd.init();                      // initialize the lcd 
  lcd.init();
  // Print a message to the LCD.
  lcd.backlight();
  lcd.setCursor(0,0);
  lcd.print("www.        ");
  lcd.setCursor(0,1);
  lcd.print("hsjh.tn.edu.tw");
  dht.begin();
  Serial.begin(9600);
  delay(3000);
  lcd.clear();

  // set SoftwareSerial port for PMS3003
  pmsSerial.begin(9600);  // PMS3003 UART has baud rate 9600
  pmsSerial.setTimeout(1500); // set the Timeout to 1500ms, longer than the data transmission periodic time of the sensor
}


void loop()
{
  // Wait a few seconds between measurements.

  // Reading temperature or humidity takes about 250 milliseconds!
  // Sensor readings may also be up to 2 seconds 'old' (its a very slow sensor)
  float h = dht.readHumidity();
  // Read temperature as Celsius (the default)
  float t = dht.readTemperature();
  // Read temperature as Fahrenheit (isFahrenheit = true)
  float f = dht.readTemperature(true);

  // Check if any reads failed and exit early (to try again).
  if (isnan(h) || isnan(t) || isnan(f)) {
    Serial.println("Failed to read from DHT sensor!");
    return;
  }

  // Compute heat index in Fahrenheit (the default)
  float hif = dht.computeHeatIndex(f, h);
  // Compute heat index in Celsius (isFahreheit = false)
  float hic = dht.computeHeatIndex(t, h, false);
 
  lcd.setCursor(0,0);
 
  lcd.print(h);
  lcd.print("% , ");

  lcd.print(t);
  lcd.print(char(0xDF));
  lcd.print("C");
 
 

 if(pmsSerial.available())
  {
    static int __index = 0;

    pmsDatabuf[__index] = pmsSerial.read();

    switch(__index)
    {
    case 0:
      __index = (pmsDatabuf[0] == 0x42) ? 1 : 0;
      break;
    case 1:
      __index = (pmsDatabuf[1] == 0x4d) ? 2 : 0;
      break;
    case 2:
      __index = 3;
      break;
    case 3:
      int __len = (pmsDatabuf[2] << 8) + pmsDatabuf[3];
      
      if(__len == (pmsDataLen-4))
      {
        if(pmsSerial.readBytes(&pmsDatabuf[4], __len) == __len)
        {
          if(CheckSum(pmsDatabuf, pmsDataLen) == 1)
          {
            int value1,value2,value3;
        value1 = (pmsDatabuf[12]<<8) + pmsDatabuf[13];
        value2 = (pmsDatabuf[14]<<8) + pmsDatabuf[15];     
         
        lcd.setCursor(0,1);
        lcd.print("PM2.5=");
        lcd.print(value1 );
        lcd.print(",");
        lcd.print("PM10=");
        lcd.print(value2 );
        lcd.print("    ");
        delay(1000);

        if((value1) < (16)){
        digitalWrite(9,0);
        digitalWrite(10,1);
        digitalWrite(11,0);}
        
        if(((15) < (value1)) & ((value1) < (36))){
        analogWrite(9,200);
        analogWrite(10,75);
        digitalWrite(11,0);}
        
        if(((35) < (value1)) & ((value1) < (55))){
        analogWrite(9,240);
        analogWrite(10,40);
        digitalWrite(11,0);}
        
        if(((54) < (value1)) & ((value1) < (151))){
        digitalWrite(9,1);
        digitalWrite(10,0);
        digitalWrite(11,0);}

        if((value1) > (150)){
        digitalWrite(9,1);
        digitalWrite(10,0);
        digitalWrite(11,1);}
          }
          
        }
      }

      __index = 0;
      break;
    }
  }
}

